import { jsxs as _, jsx as i } from "react/jsx-runtime";
import A, { useRef as P, useState as S, useLayoutEffect as $ } from "react";
import { i as j, j as X } from "../../chunks/index.Siddlo5F.js";
import { TEXT_INPUT_WRAPPER_CLASSNAME as F, r as U, TEXT_INPUT_CLASSNAME as E, TEXT_INPUT_HELPER_TEXT_CLASSNAME as T } from "../../chunks/constants.D-rfPeOH.js";
import a from "clsx";
const H = ({
  mode: t
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), W = ({
  focusMode: t
}) => a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), D = ({
  noBorder: t,
  error: s
}) => a("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), M = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return a("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "text-copy-lighter dark:text-copy-error-dark": r === "alt-system"
    });
}, q = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return a(
      T,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-lighter": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-lighter": e === "system",
      "text-copy-lighter dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": e === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": e === "alt-system"
    });
}, z = ({
  className: t,
  inputClassName: s,
  raw: e,
  disabled: r,
  noBorder: o,
  error: u,
  spacing: f,
  mode: n,
  focusMode: y
}) => {
  const p = e ? t : a(
    "relative flex w-full flex-col justify-center",
    F,
    t,
    U(f)
  ), g = e ? a(s) : a(
    E,
    s,
    "h-12 rounded-md px-4 text-base",
    H({ mode: n }),
    W({ focusMode: y }),
    D({ noBorder: o, error: u }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), x = e ? void 0 : "sr-only", k = M({
    disabled: r,
    raw: e,
    error: u,
    mode: n
  }), h = q({
    error: u,
    raw: e,
    mode: n,
    disabled: r
  });
  return {
    wrapper: p,
    input: g,
    accessibleLabel: x,
    visibleLabel: k,
    helperText: h,
    rightElement: e ? void 0 : "absolute right-3"
  };
}, G = A.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: o = !1,
    className: u,
    inputClassName: f,
    mode: n = "system",
    focusMode: y = "system",
    disabled: p = !1,
    noBorder: g = !1,
    labelId: x,
    labelHidden: k = !1,
    type: h = "text",
    helperText: c = "",
    rightElement: b,
    spacing: I,
    ...N
  }, v) => {
    const m = P(null), [C, L] = S(0), d = j({ id: t, prefix: `${E}-` }), R = `${s} error, ${c}`, l = z({
      className: u,
      inputClassName: f,
      error: r,
      raw: o,
      focusMode: y,
      disabled: p,
      noBorder: g,
      spacing: I,
      mode: n
    });
    return $(() => {
      m.current && L(m.current.offsetWidth + 18 + 10);
    }, []), /* @__PURE__ */ _("div", { className: l.wrapper, children: [
      /* @__PURE__ */ i(
        "label",
        {
          htmlFor: d,
          id: x,
          className: l.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ i(
        "input",
        {
          ref: v,
          id: d,
          name: s,
          type: h,
          disabled: p,
          placeholder: o ? void 0 : " ",
          className: l.input,
          ...c && { "aria-describedby": `${d}-helper` },
          ...r && { "aria-invalid": "true" },
          ...b && !o && { style: { paddingRight: C } },
          ...N
        }
      ),
      !o && !k && /* @__PURE__ */ i(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: d,
          className: l.visibleLabel,
          children: e
        }
      ),
      c && /* @__PURE__ */ i(
        "div",
        {
          id: `${d}-helper`,
          className: l.helperText,
          children: c
        }
      ),
      b && /* @__PURE__ */ i(
        "div",
        {
          ref: m,
          className: l.rightElement,
          children: b
        }
      ),
      r && c && /* @__PURE__ */ i(X, { politeness: "polite", clearAnnouncementDelay: 500, children: R })
    ] });
  }
);
G.displayName = "TextInput";
export {
  G as TextInput
};
